import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataConsulCatalogNodesConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/consul/d/catalog_nodes#id DataConsulCatalogNodes#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * query_options block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/consul/d/catalog_nodes#query_options DataConsulCatalogNodes#query_options}
    */
    readonly queryOptions?: DataConsulCatalogNodesQueryOptions[] | cdktf.IResolvable;
}
export interface DataConsulCatalogNodesNodes {
}
export declare function dataConsulCatalogNodesNodesToTerraform(struct?: DataConsulCatalogNodesNodes): any;
export declare class DataConsulCatalogNodesNodesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataConsulCatalogNodesNodes | undefined;
    set internalValue(value: DataConsulCatalogNodesNodes | undefined);
    get address(): string;
    get id(): string;
    private _meta;
    get meta(): cdktf.StringMap;
    get name(): string;
    private _taggedAddresses;
    get taggedAddresses(): cdktf.StringMap;
}
export declare class DataConsulCatalogNodesNodesList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataConsulCatalogNodesNodesOutputReference;
}
export interface DataConsulCatalogNodesQueryOptions {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/consul/d/catalog_nodes#allow_stale DataConsulCatalogNodes#allow_stale}
    */
    readonly allowStale?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/consul/d/catalog_nodes#datacenter DataConsulCatalogNodes#datacenter}
    */
    readonly datacenter?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/consul/d/catalog_nodes#near DataConsulCatalogNodes#near}
    */
    readonly near?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/consul/d/catalog_nodes#node_meta DataConsulCatalogNodes#node_meta}
    */
    readonly nodeMeta?: {
        [key: string]: string;
    };
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/consul/d/catalog_nodes#partition DataConsulCatalogNodes#partition}
    */
    readonly partition?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/consul/d/catalog_nodes#require_consistent DataConsulCatalogNodes#require_consistent}
    */
    readonly requireConsistent?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/consul/d/catalog_nodes#token DataConsulCatalogNodes#token}
    */
    readonly token?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/consul/d/catalog_nodes#wait_index DataConsulCatalogNodes#wait_index}
    */
    readonly waitIndex?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/consul/d/catalog_nodes#wait_time DataConsulCatalogNodes#wait_time}
    */
    readonly waitTime?: string;
}
export declare function dataConsulCatalogNodesQueryOptionsToTerraform(struct?: DataConsulCatalogNodesQueryOptions | cdktf.IResolvable): any;
export declare class DataConsulCatalogNodesQueryOptionsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataConsulCatalogNodesQueryOptions | cdktf.IResolvable | undefined;
    set internalValue(value: DataConsulCatalogNodesQueryOptions | cdktf.IResolvable | undefined);
    private _allowStale?;
    get allowStale(): boolean | cdktf.IResolvable;
    set allowStale(value: boolean | cdktf.IResolvable);
    resetAllowStale(): void;
    get allowStaleInput(): boolean | cdktf.IResolvable | undefined;
    private _datacenter?;
    get datacenter(): string;
    set datacenter(value: string);
    resetDatacenter(): void;
    get datacenterInput(): string | undefined;
    private _near?;
    get near(): string;
    set near(value: string);
    resetNear(): void;
    get nearInput(): string | undefined;
    private _nodeMeta?;
    get nodeMeta(): {
        [key: string]: string;
    };
    set nodeMeta(value: {
        [key: string]: string;
    });
    resetNodeMeta(): void;
    get nodeMetaInput(): {
        [key: string]: string;
    } | undefined;
    private _partition?;
    get partition(): string;
    set partition(value: string);
    resetPartition(): void;
    get partitionInput(): string | undefined;
    private _requireConsistent?;
    get requireConsistent(): boolean | cdktf.IResolvable;
    set requireConsistent(value: boolean | cdktf.IResolvable);
    resetRequireConsistent(): void;
    get requireConsistentInput(): boolean | cdktf.IResolvable | undefined;
    private _token?;
    get token(): string;
    set token(value: string);
    resetToken(): void;
    get tokenInput(): string | undefined;
    private _waitIndex?;
    get waitIndex(): number;
    set waitIndex(value: number);
    resetWaitIndex(): void;
    get waitIndexInput(): number | undefined;
    private _waitTime?;
    get waitTime(): string;
    set waitTime(value: string);
    resetWaitTime(): void;
    get waitTimeInput(): string | undefined;
}
export declare class DataConsulCatalogNodesQueryOptionsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataConsulCatalogNodesQueryOptions[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataConsulCatalogNodesQueryOptionsOutputReference;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/consul/d/catalog_nodes consul_catalog_nodes}
*/
export declare class DataConsulCatalogNodes extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "consul_catalog_nodes";
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/consul/d/catalog_nodes consul_catalog_nodes} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataConsulCatalogNodesConfig = {}
    */
    constructor(scope: Construct, id: string, config?: DataConsulCatalogNodesConfig);
    get datacenter(): string;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    get nodeIds(): string[];
    get nodeNames(): string[];
    private _nodes;
    get nodes(): DataConsulCatalogNodesNodesList;
    private _queryOptions;
    get queryOptions(): DataConsulCatalogNodesQueryOptionsList;
    putQueryOptions(value: DataConsulCatalogNodesQueryOptions[] | cdktf.IResolvable): void;
    resetQueryOptions(): void;
    get queryOptionsInput(): cdktf.IResolvable | DataConsulCatalogNodesQueryOptions[] | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
