import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataConsulConfigEntryConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/consul/d/config_entry#id DataConsulConfigEntry#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * The kind of config entry to read.
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/consul/d/config_entry#kind DataConsulConfigEntry#kind}
    */
    readonly kind: string;
    /**
    * The name of the config entry to read.
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/consul/d/config_entry#name DataConsulConfigEntry#name}
    */
    readonly name: string;
    /**
    * The namespace the config entry is associated with.
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/consul/d/config_entry#namespace DataConsulConfigEntry#namespace}
    */
    readonly namespace?: string;
    /**
    * The partition the config entry is associated with.
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/consul/d/config_entry#partition DataConsulConfigEntry#partition}
    */
    readonly partition?: string;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/consul/d/config_entry consul_config_entry}
*/
export declare class DataConsulConfigEntry extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "consul_config_entry";
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/consul/d/config_entry consul_config_entry} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataConsulConfigEntryConfig
    */
    constructor(scope: Construct, id: string, config: DataConsulConfigEntryConfig);
    get configJson(): string;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _kind?;
    get kind(): string;
    set kind(value: string);
    get kindInput(): string | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _namespace?;
    get namespace(): string;
    set namespace(value: string);
    resetNamespace(): void;
    get namespaceInput(): string | undefined;
    private _partition?;
    get partition(): string;
    set partition(value: string);
    resetPartition(): void;
    get partitionInput(): string | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
